/*
Bounding volumes
*/


#ifndef _YR_BVOL_H_
#define _YR_BVOL_H_


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "vector.h"
#include "ints.h"

#include "object.h"


/* axis-aligned bounding box.  min[0] <= x <= max[0], etc. */
/*
typedef struct bbox_s
    {
     vector min;
     vector max;
    } bbox_s;
*/

typedef struct bbox_s
    {
     vectype bounds[2][4];
    } bbox_s;

typedef struct bbox_s *bbox_p;

typedef struct bvol_s *bvol_p;
typedef struct bvol_s
    {
     bbox_s bbox;
     obj data;

     bvol_p child1;
     bvol_p child2;
    } bvol_s;


typedef struct ray_extra_s
    {
     vector invdir;
     int signs[3];
    } ray_extra_s;
typedef struct ray_extra_s *ray_extra_p;




inline bvol_p bvol_new();
inline vectype bbox_test_ray_ints(bbox_p bbox, ray_p ray, ray_extra_p re);
inline void bbox_combine(bbox_p r, bbox_p a, bbox_p b);

/*
inline static int bvol_cmp_sub(const void *m1, const void *m2, int axis);
static int bvol_cmp_x(const void *m1, const void *m2);
static int bvol_cmp_y(const void *m1, const void *m2);
static int bvol_cmp_z(const void *m1, const void *m2);
*/

inline int bvol_cmp_sub(const void *m1, const void *m2, int axis);
int bvol_cmp_x(const void *m1, const void *m2);
int bvol_cmp_y(const void *m1, const void *m2);
int bvol_cmp_z(const void *m1, const void *m2);

inline void bvol_sort(bvol_p *bvs, int numbvs, int axis);
inline void bvol_sort_range(bvol_p *bvs, int start, int end, int axis);
void bbox_dump(bbox_p b);
bvol_p bvol_buildtree_sub(bvol_p *bvs, int start, int end, int axis);
bvol_p bvol_buildtree(bvol_p *bvs, int numbvs);
void bvol_dumptree(bvol_p p, int level);


inline vectype bvol_ints_first_sub(ints_p ints, bvol_p tree, ray_p ray, obj ign);
inline vectype bvol_ints_first(ints_p ints, bvol_p tree, ray_p ray);
inline vectype bvol_ints_first_ignore(ints_p ints, bvol_p tree, ray_p ray, obj ign);


inline void obj_get_bbox(bbox_p a, obj o);



#endif

