/*
colors
*/


#ifndef _YR_COLOR_H_
#define _YR_COLOR_H_


#include "vector.h"


/* RGB color is the only type currently supported.  Future versions
should add some form of spectrum-based model. */
#define COLOR_TYPE_RGB 1

typedef struct color_s
    {
     int type;
     vector rgba;
    } color_s;
typedef struct color_s *color;


void color_init(color c, int type);
void color_clear(color c);
void color_add(color r, color a, color b);
void color_scale(color r, color a, vectype b);
void color_set_rgba(color c, vectype r, vectype g, vectype b, vectype a);
void color_set_rgba_vector(color c, vector rgb);
color color_new_rgba(vectype r, vectype g, vectype b, vectype a);
color color_new(int type);
void color_free(color c);


#endif
