/*
Disc object
*/

#ifndef _YR_DISC_H_
#define _YR_DISC_H_


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "vector.h"
#include "surface.h"
#include "object.h"
#include "bvol.h"



/* a disc is a circular area on a plane with a given radius about the center */
typedef struct obj_disc_s
    {
     plane_s plane;
     vectype radius;
    } obj_disc_s;
typedef struct obj_disc_s *obj_disc;

obj_disc obj_disc_new();
obj_disc obj_disc_set_basic(obj_disc o, plane_p p, vectype d);
obj_disc obj_disc_new_set_basic(plane_p p, vectype d);
inline vectype test_disc_sub(vector a, plane_p p, ray_p r, vectype d);
inline vectype test_disc(vector a, obj_disc d, ray_p r);
inline void obj_disc_bbox(bbox_p a, obj_disc s);


#endif
