/* images */


#include "vector.h"
#include "color.h"
#include "image.h"

#include "tga.h"



image image_new(int width, int height, int colortype)
{
 int x, y;
 image i = (image)malloc(sizeof(struct image_s));
 i->width = width;  i->height = height;
 i->data = (struct color_s **)malloc(sizeof(struct color_s *) * width);
 for(x = 0; x < width; x++)
    {
     i->data[x] = (struct color_s *)malloc(sizeof(struct color_s) * height);
     for(y = 0; y < height; y++)
        {
         color_init(&(i->data[x][y]), colortype);
        }
    }
 return i;
}

void image_free(image i)
{
 int x;
 if(!i->data)
    {
     fprintf(stderr, "Trying to free non-allocated image data!\n");
     return;
    }
 for(x = 0; x < i->width; x++)
    {
     free(i->data[x]);
    }
 free(i->data);
 i->data = NULL;
}


/* for now, we'll make 0-1 be 0-255...  and right now we only do RGB too! */
void image_write_tga(image i, char *filename)
{
 int x, y, c, t;
 tga_image *ti = tga_new(i->width, i->height);
 for(x = 0; x < i->width; x++)
     for(y = 0; y < i->height; y++)
         for(c = 0; c < 3; c++)
            {
             t = (int)(255.0 * i->data[x][y].rgba[c] * i->data[x][y].rgba[3]);
             if(t < 0) t = 0;
             if(t > 255) t = 255;
             tga_setpixel(ti, x, y, c, t);
            }
 tga_write(ti, filename);
}



