/*
Bounding volumes
*/


#ifndef _YR_INTS_H_
#define _YR_INTS_H_


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "vector.h"

#include "object.h"



typedef struct ints_s
    {
     long bits;
     ray_s incray;
     obj data;
     vectype dist;
     vector target;
     vector normal;
     int side;  /* 0 = front, 1 = back */
    } ints_s;
typedef struct ints_s *ints_p;

#define INTS_HIT    (1<<0)
#define INTS_TARGET (1<<1)
#define INTS_NORMAL (1<<2)


inline void ints_setbit(ints_p i, long bits);
inline long ints_getbit(ints_p i, long bits);
inline long ints_testbit(ints_p i, long bits);
inline void ints_get_target(ints_p i);
inline void ints_get_normal(ints_p i);



#endif

