/*
matrix math
*/

#ifndef _YR_MATRIX_H_
#define _YR_MATRIX_H_

#include "matrix.h"


typedef vectype matrix[4][4];



inline void matrix_mulmm(matrix r, matrix a, matrix b);
inline void matrix_mulmm_safe(matrix r, matrix a, matrix b);
inline void matrix_mulmv(vector r, matrix a, vector b);
inline void matrix_mulmv(vector r, matrix a, vector b);
inline void matrix_mulmv_safe(vector r, matrix a, vector b);
void print_strip(char e, char m);
void print_row(vector v);
void matrix_print(matrix m);
void vector_print(vector v);
inline void matrix_identity(matrix m);
inline void matrix_translate_vector(matrix m, vector v);
inline void matrix_rotate_axis(matrix m, int axis, vectype a);
inline void matrix_rotate_vector(matrix m, vector v, vectype a);
void matrix_lookat(matrix m, vector eye, vector center, vector up);
void matrix_perspective(matrix m, vectype fov, vectype aspect);
void matrix_camera(matrix m, vector eye, vector center, vector up, vectype fov, vectype aspect);
void matrix_copy(matrix b, matrix a);
void matrix_random(matrix a);
void matrix_random_int(matrix a);
void matrix_inverse(matrix b, matrix a);
inline void matrix_translate(matrix m, vectype x, vectype y, vectype z);
inline void matrix_scale(matrix m, vectype x, vectype y, vectype z);
inline void matrix_scale_vector(matrix m, vector v);
void matrix_camera_image(matrix m, vector eye, vector center, vector up, vectype fov, vectype width, vectype height);
void matrix_camera_image_inverse(matrix m, vector eye, vector center, vector up, vectype fov, vectype width, vectype height);



#endif

