/*
Objects.
*/


#ifndef _YR_OBJECT_H_
#define _YR_OBJECT_H_


#include "surface.h"


enum objtype { obj_type_none, obj_type_plane, obj_type_disc, obj_type_yes, obj_type_sphere, obj_type_triangle };
typedef struct obj_s
    {
     enum objtype type;
     void *data;
     surface surf;
    } obj_s;
typedef struct obj_s *obj;


#include "bvol.h"


#include "vector.h"

/*
#include "sphere.h"
#include "disc.h"
*/

obj obj_new();
obj obj_set(obj r, enum objtype t, void *o);
obj obj_new_set(enum objtype t, void *o);
obj obj_set_surface(obj o, surface s);
inline vectype obj_test(vector a, obj o, ray_p r);
inline void obj_get_target(vector a, obj o, ray_p r, vectype t);
inline void obj_get_normal(vector a, obj o, vector p);



#endif
