/*
Surfaces
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "vector.h"
#include "color.h"
#include "surface.h"


/* this should be broken up into a "phong" struture... */

surface surface_new()
{
 surface s = malloc(sizeof(surface_s));
 s->diff = 0.0;
 s->diffcolor = NULL;
 s->spec = 0.0;
 s->phong = 1.0;
 s->speccolor = NULL;
 s->mirror = 0.0;
 s->glossangle = 0.0;
 return s;
}

surface surface_new_set_rgbdsp(vectype r, vectype g, vectype b, vectype d, vectype ss, vectype p)
{
 surface s = surface_new();
 s->diff = d;
 s->spec = ss;
 s->phong = p;
 s->diffcolor = s->speccolor = color_new_rgba(r, g, b, 1.0);
 return s;
}


surface surface_new_set_mirror()
{
 surface s = surface_new();
 s->diffcolor = s->speccolor = color_new_rgba(1.0, 1.0, 1.0, 1.0);
 s->diff = 0.4;
 s->spec = 0.2;
 s->phong = 10;
 s->mirror = 0.90;
 return s;
}


void surface_set_diff(surface s, color diffcolor, vectype r)
{
 s->diffcolor = diffcolor;
 s->diff = r;
}

void surface_set_spec(surface s, color speccolor, vectype ss, vectype p)
{
 s->speccolor = speccolor;
 s->spec = ss;
 s->phong = p;
}

void surface_set_mirror(surface s, vectype m, vectype d)
{
 s->mirror = m;
 s->glossangle = d;
}




