/*
Surfaces
*/


#ifndef _YR_SURFACE_H_
#define _YR_SURFACE_H_


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "vector.h"
#include "color.h"


/* all the properties a surface can have.  This should have some fancy BRDF-based solution at some point...  and the reflactance and color
options could be combined, but this is simpler.  */
typedef struct surface_s
    {
     vectype diff;         /* lambertian diffuse reflectance */
     color diffcolor;      /* diffuse color pointer */
     vectype spec;         /* specular reflectance */
     vectype phong;        /* phong specular exponent */
     color speccolor;      /* specular color pointer */
     vectype mirror;       /* mirror reflectance, uses same color as specular */
     vectype glossangle;   /* limit of the random angle for "glossy" mirror surfaces. */
     vectype trans;        /* transmission amount */
     vectype refidx;       /* refractive index */
    } surface_s;
typedef struct surface_s *surface;


surface surface_new();
void surface_set_diff(surface s, color diffcolor, vectype r);
void surface_set_spec(surface s, color speccolor, vectype ss, vectype p);
void surface_set_mirror(surface s, vectype m, vectype d);
surface surface_new_set_rgbdsp(vectype r, vectype g, vectype b, vectype d, vectype s, vectype p);
surface surface_new_set_mirror();


#endif

