/*
Triangle object
*/


#ifndef _YR_TRIANGLE_H_
#define _YR_TRIANGLE_H_



#include "vector.h"
#include "vertex.h"



/* triangle acceleration info */
typedef struct obj_triangle_accel_s
    {
     plane_s plane;        /* triangle plane.  point isn't really needed, but a plane structure makes it easier to call the intersection code. */
     vector n12, n23, n31; /* plane equations for the three sides */
    } obj_triangle_accel_s;
typedef struct obj_triangle_accel_s *obj_triangle_accel;



/* Triangle.  Only the three points need to be stored, but storing everything 
else shifts the speed/memory tradeoff greatly towards speed */

typedef struct obj_triangle_s
    {
     /* vector t1, t2, t3; */   /* the three points */
     vertex v1, v2, v3;
     obj_triangle_accel accel;
     /* vector vn1, vn2, vn3; */ /* vertex normals! */
    } obj_triangle_s;
typedef struct obj_triangle_s *obj_triangle;



obj_triangle obj_triangle_new();
/*
obj_triangle obj_triangle_set_basic(obj_triangle o, vector t1, vector t2, vector t3);
obj_triangle obj_triangle_new_set_basic(vector t1, vector t2, vector t3);
*/
obj_triangle obj_triangle_set_basic(obj_triangle o, vertex t1, vertex t2, vertex t3);
obj_triangle obj_triangle_new_set_basic(vertex t1, vertex t2, vertex t3);
inline vectype test_triangle(vector target, obj_triangle o, ray_p ray);
inline void obj_triangle_bbox(bbox_p a, obj_triangle s);


void triangle_compute_normal(vector n, vector t1, vector t2, vector t3);
/* void obj_triangle_set_vertnorms(obj_triangle o, vector n1, vector n2, vector n3); */
void obj_triangle_get_normal(vector n, obj_triangle o, vector point);


obj_triangle obj_triangle_new_set_basic_vector(vector t1, vector t2, vector t3);


#endif
