/*
The world!
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "vector.h"
#include "surface.h"
#include "object.h"
#include "world.h"
#include "bvol.h"



void world_init(world w)
{
 w->numobjs = 0;
 w->allocobjs = 10;
 w->objs = malloc(w->allocobjs * sizeof(obj));
 w->bvs = malloc(w->allocobjs * sizeof(bvol_p));
}

void world_add_obj(world w, obj o)
{
 w->objs[w->numobjs] = o;
 w->bvs[w->numobjs] = bvol_new();

 obj_get_bbox(&(w->bvs[w->numobjs]->bbox), o);
 w->bvs[w->numobjs]->data = o;


 w->numobjs++;
 if(w->numobjs >= w->allocobjs)
    {
     w->allocobjs += 10 + w->allocobjs / 10;
     /* fprintf(stderr, "DEBUG: world_add_obj: allocated %d more object pointers for %d used.\n", w->allocobjs - w->numobjs, w->numobjs); */
     w->objs = realloc(w->objs, w->allocobjs * sizeof(obj));
     w->bvs = realloc(w->bvs, w->allocobjs * sizeof(bvol_p));
    }

 if((w->numobjs % 1000) == 999)
    fprintf(stderr, ".");

}



obj world_ints_first(world w, vector d, vectype *zm, ray_p r)
{
 int t, tmin = -1;
 vectype z, zmin = -1;
 vector k = {0,0,0};
 
 for(t = 0; t < w->numobjs; t++)
    {
     if((z = obj_test(k, w->objs[t], r)) > 0)
        {
         if(tmin < 0 || z < zmin)
            {
             tmin = t;
             zmin = z;
             vector_copy_3d(d, k);
            }
        }
    }

 *zm = zmin;
 if(tmin >= 0)
    {
     return w->objs[tmin];
    }

 return NULL;
}




